package td;

/**
 * Une Pile implmente en utilisant une Liste simplement chaine
 * @author jub
 * @param <X> Le type des lment de la pile
 */
public class Pile <X>{
	/**
	 * La pile est ralise en utilisant une Liste
	 */
	private Liste<X> liste;
	public Pile()
	{
		liste = new Liste<X>();
	}
	
	/**
	 * Place un lment au sommet de la Pile
	 * @param val la valeur de l'lment
	 */
	public void push(X val)
	{
		this.liste.insertTete(val);
	}
	
	/**
	 * @return la valeur au sommet de la Pile
	 */
	public X pop()
	{
		X res;
		res = this.liste.getPremier();
		this.liste.suppressionTete();
		return res;
	}
	
	/**
	 * @return vrai si la pile est vide, faux sinon.
	 */
	public boolean estVide()
	{
		return this.liste.estVide();
	}

	@Override
	public String toString() {
		return this.liste.toString();
	}
	
	
}
